extern crate glium;
extern crate graphics;
extern crate glium_graphics;

use graphics::{Graphics, Context, Viewport};
use glium_graphics::{Glium2d, OpenGL};


fn main() {
    use glium::DisplayBuild;

    let mut window = glium::glutin::WindowBuilder::new()
        .build_glium()
        .unwrap();

    let mut graphics = Glium2d::new(OpenGL::V3_2, &window);

    let view = HorRow { views: vec![] };

    loop {
        // draw everything here
        let mut frame = window.draw();
        graphics.draw(&mut frame,
                      Viewport {
                          rect: [0, 0, 1, 1],
                          draw_size: [1, 1],
                          window_size: [1, 1],
                      },
                      |context, graphics| {
                          view.draw(graphics, context);
                      });
        frame.finish().unwrap();
    }
}

pub trait Draw<G: Graphics> {
    fn draw(&self, graphics: &mut G, context: Context);
}

pub struct HorRow<G: Graphics> {
    views: Vec<Box<Draw<G>>>,
}

impl<G: Graphics> Draw<G> for HorRow<G> {
    fn draw(&self, graphics: &mut G, context: Context) {}
}
